<?php
namespace SpaceshipDomainRegistrar;

class Utils
{
    public static $IsDebugMode = false;
    private static $logFile = __DIR__ . '/../logs/spaceship.log';

    public static function log(string $action, $data = null): void
    {
        if (!self::$IsDebugMode) return;

        $logEntry = json_encode([
            'timestamp' => date('c'),
            'action' => $action,
            'data' => $data
        ], JSON_PRETTY_PRINT) . PHP_EOL;

        @file_put_contents(self::$logFile, $logEntry, FILE_APPEND);
    }

    public static function validateDomain(string $domain): bool
    {
        return (bool)preg_match('/^([a-z0-9]+(-[a-z0-9]+)*\.)+[a-z]{2,}$/i', $domain);
    }

    public static function parseWhoisContact(array $params): array
    {
        return [
            'name' => trim($params['firstname'] . ' ' . $params['lastname']),
            'organization' => $params['companyname'] ?? '',
            'street' => [
                $params['address1'] ?? '',
                $params['address2'] ?? ''
            ],
            'city' => $params['city'] ?? '',
            'state' => $params['state'] ?? '',
            'postal_code' => $params['postcode'] ?? '',
            'country' => $params['country'] ?? '',
            'phone' => $params['phonenumber'] ?? '',
            'email' => $params['email'] ?? ''
        ];
    }
}